#ifndef STDTYPES_H_
#define STDTYPES_H_

/* ########################################################################################################################################################## */
/* # Includes #################################################################################################################################### Includes # */
/* ########################################################################################################################################################## */

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>
#include <sys/types.h>

/* ########################################################################################################################################################## */
/* # Define Definitions ################################################################################################################ Define Definitions # */
/* ########################################################################################################################################################## */

#ifndef bool
#	define bool int
#endif

#ifndef true
#	define true 1
#endif

#ifndef false
#	define false 0
#endif

#ifndef ENABLED
#	define ENABLED 1
#endif

#ifndef DISABLED
#	define DISABLED 0
#endif

#ifndef NULL_PTR
#	define NULL_PTR ((void *)0)
#endif

#ifndef NULL
#	define NULL NULL_PTR
#endif

#ifndef EXIT_SUCCESS
#	define EXIT_SUCCESS 0
#endif

#ifndef EXIT_FAILURE
#	define EXIT_FAILURE 1
#endif

/* ########################################################################################################################################################## */
/* # Macro Definitions ################################################################################################################## Macro Definitions # */
/* ########################################################################################################################################################## */

/* ########################################################################################################################################################## */
/* # Type Definitions #################################################################################################################### Type Definitions # */
/* ########################################################################################################################################################## */

#ifndef sint
typedef int sint;
#endif

#ifndef uint
typedef unsigned int uint;
#endif

/* ---------------------------------------------------------------------------------------------------------------------------------------------------------- */

#ifndef sint8
typedef int8_t sint8; /*                   -128 .. +127 */
#endif

#ifndef uint8
typedef uint8_t uint8; /*                     0 .. 255 */
#endif

#ifndef sint16
typedef int16_t sint16; /*               -32768 .. +32767 */
#endif

#ifndef uint16
typedef uint16_t uint16; /*                   0 .. 65535 */
#endif

#ifndef sint32
typedef int32_t sint32; /*          -2147483648 .. +2147483647 */
#endif

#ifndef uint32
typedef uint32_t uint32; /*                   0 .. 4294967295 */
#endif

#ifndef sint64
typedef int64_t sint64; /* -9223372036854775808 .. +9223372036854775807*/
#endif

#ifndef uint64
typedef uint64_t uint64; /*                   0 .. 18446744073709551615*/
#endif

/* ---------------------------------------------------------------------------------------------------------------------------------------------------------- */

#ifndef sint8_fast
typedef int_fast8_t sint8_fast;
#endif

#ifndef uint8_fast
typedef uint_fast8_t uint8_fast;
#endif

#ifndef sint16_fast
typedef int_fast16_t sint16_fast;
#endif

#ifndef uint16_fast
typedef uint_fast16_t uint16_fast;
#endif

#ifndef sint32_fast
typedef int_fast32_t sint32_fast;
#endif

#ifndef uint32_fast
typedef uint_fast32_t uint32_fast;
#endif

#ifndef sint64_fast
typedef int_fast64_t sint64_fast;
#endif

#ifndef uint64_fast
typedef uint_fast64_t uint64_fast;
#endif

/* ---------------------------------------------------------------------------------------------------------------------------------------------------------- */

#ifndef BYTE
typedef uint8 BYTE;
#endif

#ifndef DoubleBYTE
typedef uint16 DoubleBYTE;
#endif

#ifndef QuadBYTE
typedef uint32 QuadBYTE;
#endif

#ifndef OctoBYTE
typedef uint64 OctoBYTE;
#endif

/*
#ifndef WORD
typedef uint16 WORD;
#endif

#ifndef DWORD
typedef uint32 DWORD;
#endif

#ifndef QWORD
typedef uint64 QWORD;
#endif
*/

/* ---------------------------------------------------------------------------------------------------------------------------------------------------------- */

#ifndef EXITCODE
typedef int EXITCODE;
#endif

/* ---------------------------------------------------------------------------------------------------------------------------------------------------------- */

#ifndef float32
typedef float float32;
#endif

/* ########################################################################################################################################################## */
/* # Variable Declarations ########################################################################################################## Variable Declarations # */
/* ########################################################################################################################################################## */

/* ########################################################################################################################################################## */
/* # Static Inline Functions ###################################################################################################### Static Inline Functions # */
/* ########################################################################################################################################################## */

/* ########################################################################################################################################################## */
/* # Function Prototypes ############################################################################################################## Function Prototypes # */
/* ########################################################################################################################################################## */

/* ########################################################################################################################################################## */
#endif /* STDTYPES_H_ */
/* EOF */
